Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_function.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_function.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_function.php	(revision )
@@ -16,6 +16,7 @@
  */
 class Smarty_Internal_Compile_Function extends Smarty_Internal_CompileBase
 {
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -23,6 +24,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -30,6 +32,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -41,54 +44,31 @@
     /**
      * Compiles code for the {function} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
-     * @return boolean true
+     * @return bool true
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
+        $compiler->loopNesting++;
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
 
         if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
+            $compiler->trigger_template_error('nocache option not allowed', null, true);
         }
         unset($_attr['nocache']);
-        $save = array($_attr, $compiler->parser->current_buffer,
-                      $compiler->template->has_nocache_code, $compiler->template->required_plugins);
-        $this->openTag($compiler, 'function', $save);
         $_name = trim($_attr['name'], "'\"");
-        unset($_attr['name']);
-        // set flag that we are compiling a template function
-        $compiler->compiles_template_function = true;
-        $compiler->template->properties['function'][$_name]['parameter'] = array();
-        /** @var Smarty_Internal_Template $_smarty_tpl
-         * used in evaluated code
-         */
-        $_smarty_tpl = $compiler->template;
-        foreach ($_attr as $_key => $_data) {
-            eval ('$tmp=' . $_data . ';');
-            $compiler->template->properties['function'][$_name]['parameter'][$_key] = $tmp;
-        }
-        $compiler->smarty->template_functions[$_name]['parameter'] = $compiler->template->properties['function'][$_name]['parameter'];
-        if ($compiler->template->caching) {
-            $output = '';
-        } else {
-            $output = "<?php if (!function_exists('smarty_template_function_{$_name}')) {
-    function smarty_template_function_{$_name}(\$_smarty_tpl,\$params) {
-    \$saved_tpl_vars = \$_smarty_tpl->tpl_vars;
-    foreach (\$_smarty_tpl->smarty->template_functions['{$_name}']['parameter'] as \$key => \$value) {\$_smarty_tpl->tpl_vars[\$key] = new Smarty_variable(\$value);};
-    foreach (\$params as \$key => \$value) {\$_smarty_tpl->tpl_vars[\$key] = new Smarty_variable(\$value);}?>";
-        }
+        $compiler->parent_compiler->tpl_function[$_name] = $compiler->parent_compiler->template->tpl_function[$_name] = array();
+        $save = array($_attr, $compiler->parser->current_buffer, $compiler->template->compiled->has_nocache_code,
+                      $compiler->template->caching);
+        $this->openTag($compiler, 'function', $save);
         // Init temporary context
-        $compiler->template->required_plugins = array('compiled' => array(), 'nocache' => array());
-        $compiler->parser->current_buffer = new _smarty_template_buffer($compiler->parser);
-        $compiler->parser->current_buffer->append_subtree(new _smarty_tag($compiler->parser, $output));
-        $compiler->template->has_nocache_code = false;
-        $compiler->has_code = false;
-        $compiler->template->properties['function'][$_name]['compiled'] = '';
+        $compiler->parser->current_buffer = new Smarty_Internal_ParseTree_Template();
+        $compiler->template->compiled->has_nocache_code = false;
         return true;
     }
 }
@@ -101,62 +81,130 @@
  */
 class Smarty_Internal_Compile_Functionclose extends Smarty_Internal_CompileBase
 {
+
     /**
+     * Compiler object
+     *
+     * @var object
+     */
+    private $compiler = null;
+
+    /**
      * Compiles code for the {/function} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param object|\Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
      *
-     * @return boolean true
+     * @return bool true
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
-        $_attr = $this->getAttributes($compiler, $args);
+        $compiler->loopNesting--;
+        $this->compiler = $compiler;
         $saved_data = $this->closeTag($compiler, array('function'));
-        $_name = trim($saved_data[0]['name'], "'\"");
-        // build plugin include code
-        $plugins_string = '';
-        if (!empty($compiler->template->required_plugins['compiled'])) {
-            $plugins_string = '<?php ';
-            foreach ($compiler->template->required_plugins['compiled'] as $tmp) {
-                foreach ($tmp as $data) {
-                    $plugins_string .= "if (!is_callable('{$data['function']}')) include '{$data['file']}';\n";
+        $_attr = $saved_data[0];
+        $_name = trim($_attr['name'], "'\"");
+        $compiler->parent_compiler->tpl_function[$_name]['called_functions'] = $compiler->parent_compiler->template->tpl_function[$_name]['called_functions'] = $compiler->called_functions;
+        $compiler->parent_compiler->tpl_function[$_name]['compiled_filepath'] = $compiler->parent_compiler->template->tpl_function[$_name]['compiled_filepath'] = $compiler->parent_compiler->template->compiled->filepath;
+        $compiler->parent_compiler->tpl_function[$_name]['uid'] = $compiler->parent_compiler->template->tpl_function[$_name]['uid'] = $compiler->template->source->uid;
+        $compiler->called_functions = array();
+        $_parameter = $_attr;
+        unset($_parameter['name']);
+        // default parameter
+        $_paramsArray = array();
+        foreach ($_parameter as $_key => $_value) {
+            if (is_int($_key)) {
+                $_paramsArray[] = "$_key=>$_value";
+            } else {
+                $_paramsArray[] = "'$_key'=>$_value";
-                }
-            }
+            }
+        }
-            $plugins_string .= '?>';
+        if (!empty($_paramsArray)) {
+            $_params = 'array(' . implode(",", $_paramsArray) . ')';
+            $_paramsCode = "\$params = array_merge($_params, \$params);\n";
+        } else {
+            $_paramsCode = '';
         }
-        if (!empty($compiler->template->required_plugins['nocache'])) {
-            $plugins_string .= "<?php echo '/*%%SmartyNocache:{$compiler->template->properties['nocache_hash']}%%*/<?php ";
-            foreach ($compiler->template->required_plugins['nocache'] as $tmp) {
-                foreach ($tmp as $data) {
-                    $plugins_string .= "if (!is_callable(\'{$data['function']}\')) include \'{$data['file']}\';\n";
+        $_functionCode = $compiler->parser->current_buffer;
+        // setup buffer for template function code
+        $compiler->parser->current_buffer = new Smarty_Internal_ParseTree_Template();
+
+        $_funcName = "smarty_template_function_{$_name}_{$compiler->template->compiled->nocache_hash}";
+        $_funcNameCaching = $_funcName . '_nocache';
+        if ($compiler->template->compiled->has_nocache_code) {
+            $compiler->parent_compiler->tpl_function[$_name]['call_name_caching'] = $compiler->parent_compiler->template->tpl_function[$_name]['call_name_caching'] = $_funcNameCaching;
+            $output = "<?php\n";
+            $output .= "/* {$_funcNameCaching} */\n";
+            $output .= "if (!function_exists('{$_funcNameCaching}')) {\n";
+            $output .= "function {$_funcNameCaching} (\$_smarty_tpl,\$params) {\n";
+            $output .= "ob_start();\n";
+            $output .= "\$_smarty_tpl->compiled->has_nocache_code = true;\n";
+            $output .= $_paramsCode;
+            $output .= "\$_smarty_tpl->_cache['saved_tpl_vars'][] = \$_smarty_tpl->tpl_vars;\n";
+            $output .= "foreach (\$params as \$key => \$value) {\n\$_smarty_tpl->tpl_vars[\$key] = new Smarty_Variable(\$value);\n}";
+            $output .= "\$params = var_export(\$params, true);\n";
+            $output .= "echo \"/*%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%*/<?php ";
+            $output .= "\\\$saved_tpl_vars = \\\$_smarty_tpl->tpl_vars;\nforeach (\$params as \\\$key => \\\$value) {\n\\\$_smarty_tpl->tpl_vars[\\\$key] = new Smarty_Variable(\\\$value);\n}\n?>";
+            $output .= "/*/%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%*/\n\";?>";
+            $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $output));
+            $compiler->parser->current_buffer->append_subtree($compiler->parser, $_functionCode);
+            $output = "<?php echo \"/*%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%*/<?php ";
+            $output .= "foreach (Smarty::\\\$global_tpl_vars as \\\$key => \\\$value){\n";
+            $output .= "if (!isset(\\\$_smarty_tpl->tpl_vars[\\\$key]) || \\\$_smarty_tpl->tpl_vars[\\\$key] === \\\$value) \\\$saved_tpl_vars[\\\$key] = \\\$value;\n}\n";
+            $output .= "\\\$_smarty_tpl->tpl_vars = \\\$saved_tpl_vars;?>\n";
+            $output .= "/*/%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%*/\";\n?>";
+            $output .= "<?php echo str_replace('{$compiler->template->compiled->nocache_hash}', \$_smarty_tpl->compiled->nocache_hash, ob_get_clean());\n";
+            $output .= "\$_smarty_tpl->tpl_vars = array_pop(\$_smarty_tpl->_cache['saved_tpl_vars']);\n}\n}\n";
+            $output .= "/*/ {$_funcName}_nocache */\n\n";
+            $output .= "?>\n";
+            $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $output));
+            $_functionCode = new Smarty_Internal_ParseTree_Tag($compiler->parser, preg_replace_callback("/((<\?php )?echo '\/\*%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%\*\/([\S\s]*?)\/\*\/%%SmartyNocache:{$compiler->template->compiled->nocache_hash}%%\*\/';(\?>\n)?)/", array($this,
+                                                                                                                                                                                                                                                                                                          'removeNocache'), $_functionCode->to_smarty_php($compiler->parser)));
-                }
+        }
+        $compiler->parent_compiler->tpl_function[$_name]['call_name'] = $compiler->parent_compiler->template->tpl_function[$_name]['call_name'] = $_funcName;
+        $output = "<?php\n";
+        $output .= "/* {$_funcName} */\n";
+        $output .= "if (!function_exists('{$_funcName}')) {\n";
+        $output .= "function {$_funcName}(\$_smarty_tpl,\$params) {\n";
+        $output .= "\$saved_tpl_vars = \$_smarty_tpl->tpl_vars;\n";
+        $output .= $_paramsCode;
+        $output .= "foreach (\$params as \$key => \$value) {\n\$_smarty_tpl->tpl_vars[\$key] = new Smarty_Variable(\$value);\n}?>";
+        $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $output));
+        $compiler->parser->current_buffer->append_subtree($compiler->parser, $_functionCode);
+        $output = "<?php foreach (Smarty::\$global_tpl_vars as \$key => \$value){\n";
+        $output .= "if (!isset(\$_smarty_tpl->tpl_vars[\$key]) || \$_smarty_tpl->tpl_vars[\$key] === \$value) \$saved_tpl_vars[\$key] = \$value;\n}\n";
+        $output .= "\$_smarty_tpl->tpl_vars = \$saved_tpl_vars;\n}\n}\n";
+        $output .= "/*/ {$_funcName} */\n\n";
+        $output .= "?>\n";
+        $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $output));
+        $compiler->parent_compiler->blockOrFunctionCode .= $compiler->parser->current_buffer->to_smarty_php($compiler->parser);
+        // nocache plugins must be copied
+        if (!empty($compiler->template->compiled->required_plugins['nocache'])) {
+            foreach ($compiler->template->compiled->required_plugins['nocache'] as $plugin => $tmp) {
+                foreach ($tmp as $type => $data) {
+                    $compiler->parent_compiler->template->compiled->required_plugins['compiled'][$plugin][$type] = $data;
-            }
+                }
-            $plugins_string .= "?>/*/%%SmartyNocache:{$compiler->template->properties['nocache_hash']}%%*/';?>\n";
-        }
+            }
-         // if caching save template function for possible nocache call
-        if ($compiler->template->caching) {
-            $compiler->template->properties['function'][$_name]['compiled'] .= $plugins_string
-                . $compiler->parser->current_buffer->to_smarty_php();
-            $compiler->template->properties['function'][$_name]['nocache_hash'] = $compiler->template->properties['nocache_hash'];
-            $compiler->template->properties['function'][$_name]['has_nocache_code'] = $compiler->template->has_nocache_code;
-            $compiler->template->properties['function'][$_name]['called_functions'] = $compiler->called_functions;
-            $compiler->called_functions = array();
-            $compiler->smarty->template_functions[$_name] = $compiler->template->properties['function'][$_name];
-            $compiler->has_code = false;
-            $output = true;
-        } else {
-            $output = $plugins_string . $compiler->parser->current_buffer->to_smarty_php() . "<?php \$_smarty_tpl->tpl_vars = \$saved_tpl_vars;
-foreach (Smarty::\$global_tpl_vars as \$key => \$value) if(!isset(\$_smarty_tpl->tpl_vars[\$key])) \$_smarty_tpl->tpl_vars[\$key] = \$value;}}?>\n";
         }
-        // reset flag that we are compiling a template function
-        $compiler->compiles_template_function = false;
-        // restore old compiler status
+        // restore old buffer
+
         $compiler->parser->current_buffer = $saved_data[1];
-        $compiler->template->has_nocache_code = $compiler->template->has_nocache_code | $saved_data[2];
-        $compiler->template->required_plugins = $saved_data[3];
+        // restore old status
+        $compiler->template->compiled->has_nocache_code = $saved_data[2];
+        $compiler->template->caching = $saved_data[3];
+        return true;
+    }
 
-        return $output;
+    /**
+     * @param $match
+     *
+     * @return mixed
+     */
+    function removeNocache($match)
+    {
+        $code = preg_replace("/((<\?php )?echo '\/\*%%SmartyNocache:{$this->compiler->template->compiled->nocache_hash}%%\*\/)|(\/\*\/%%SmartyNocache:{$this->compiler->template->compiled->nocache_hash}%%\*\/';(\?>\n)?)/", '', $match[0]);
+        $code = str_replace(array('\\\'', '\\\\\''), array('\'', '\\\''), $code);
+        return $code;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_smartytemplatecompiler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_smartytemplatecompiler.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_smartytemplatecompiler.php	(revision )
@@ -9,11 +9,6 @@
  */
 
 /**
- * @ignore
- */
-include 'smarty_internal_parsetree.php';
-
-/**
  * Class SmartyTemplateCompiler
  *
  * @package    Smarty
@@ -36,32 +31,32 @@
     public $parser_class;
 
     /**
-     * Lexer object
+     * array of vars which can be compiled in local scope
      *
-     * @var object
+     * @var array
      */
-    public $lex;
+    public $local_var = array();
 
     /**
-     * Parser object
+     * array of callbacks called when the normal compile process of template is finished
      *
-     * @var object
+     * @var array
      */
-    public $parser;
+    public $postCompileCallbacks = array();
 
     /**
-     * Smarty object
+     * prefix code
      *
-     * @var object
+     * @var string
      */
-    public $smarty;
+    public $prefixCompiledCode = '';
 
     /**
-     * array of vars which can be compiled in local scope
+     * postfix code
      *
-     * @var array
+     * @var string
      */
-    public $local_var = array();
+    public $postfixCompiledCode = '';
 
     /**
      * Initialize compiler
@@ -70,10 +65,9 @@
      * @param string $parser_class class name
      * @param Smarty $smarty       global instance
      */
-    public function __construct($lexer_class, $parser_class, $smarty)
+    public function __construct($lexer_class, $parser_class, Smarty $smarty)
     {
-        $this->smarty = $smarty;
-        parent::__construct();
+        parent::__construct($smarty);
         // get required plugins
         $this->lexer_class = $lexer_class;
         $this->parser_class = $parser_class;
@@ -83,20 +77,22 @@
      * method to compile a Smarty template
      *
      * @param  mixed $_content template source
+     * @param bool   $isTemplateSource
      *
-     * @return bool  true if compiling succeeded, false if it failed
+     * @return bool true if compiling succeeded, false if it failed
+     * @throws \SmartyCompilerException
      */
-    protected function doCompile($_content)
+    protected function doCompile($_content, $isTemplateSource = false)
     {
         /* here is where the compiling takes place. Smarty
           tags in the templates are replaces with PHP code,
           then written to compiled files. */
         // init the lexer/parser to compile the template
-        $this->lex = new $this->lexer_class($_content, $this);
-        $this->parser = new $this->parser_class($this->lex, $this);
-        if ($this->inheritance_child) {
-            // start state on child templates
-            $this->lex->yypushstate(Smarty_Internal_Templatelexer::CHILDBODY);
+        $this->parser =
+            new $this->parser_class(new $this->lexer_class(str_replace(array("\r\n", "\r"), "\n", $_content), $this),
+                                    $this);
+        if ($isTemplateSource && $this->template->caching) {
+            $this->parser->insertPhpCode("<?php\n\$_smarty_tpl->compiled->nocache_hash = '{$this->nocache_hash}';\n?>\n");
         }
         if (function_exists('mb_internal_encoding') && ((int) ini_get('mbstring.func_overload')) & 2) {
             $mbEncoding = mb_internal_encoding();
@@ -107,21 +103,17 @@
 
         if ($this->smarty->_parserdebug) {
             $this->parser->PrintTrace();
-            $this->lex->PrintTrace();
+            $this->parser->lex->PrintTrace();
         }
         // get tokens from lexer and parse them
-        while ($this->lex->yylex() && !$this->abort_and_recompile) {
+        while ($this->parser->lex->yylex()) {
             if ($this->smarty->_parserdebug) {
-                echo "<pre>Line {$this->lex->line} Parsing  {$this->parser->yyTokenName[$this->lex->token]} Token " .
-                    htmlentities($this->lex->value) . "</pre>";
+                echo "<pre>Line {$this->parser->lex->line} Parsing  {$this->parser->yyTokenName[$this->parser->lex->token]} Token " .
+                    htmlentities($this->parser->lex->value) . "</pre>";
             }
-            $this->parser->doParse($this->lex->token, $this->lex->value);
+            $this->parser->doParse($this->parser->lex->token, $this->parser->lex->value);
         }
 
-        if ($this->abort_and_recompile) {
-            // exit here on abort
-            return false;
-        }
         // finish parsing process
         $this->parser->doParse(0, 0);
         if ($mbEncoding) {
@@ -131,10 +123,47 @@
         if (count($this->_tag_stack) > 0) {
             // get stacked info
             list($openTag, $_data) = array_pop($this->_tag_stack);
-            $this->trigger_template_error("unclosed {$this->smarty->left_delimiter}" . $openTag . "{$this->smarty->right_delimiter} tag");
+            $this->trigger_template_error("unclosed {$this->smarty->left_delimiter}" . $openTag .
+                                          "{$this->smarty->right_delimiter} tag");
         }
+        // call post compile callbacks
+        foreach ($this->postCompileCallbacks as $cb) {
+            $parameter = $cb;
+            $parameter[0] = $this;
+            call_user_func_array($cb[0], $parameter);
+        }
         // return compiled code
-        // return str_replace(array("? >\n<?php","? ><?php"), array('',''), $this->parser->retvalue);
-        return $this->parser->retvalue;
+        return $this->prefixCompiledCode . $this->parser->retvalue . $this->postfixCompiledCode;
+    }
+
+    /**
+     * Register a post compile callback
+     * - when the callback is called after template compiling the compiler object will be inserted as first parameter
+     *
+     * @param callback $callback
+     * @param array    $parameter optional parameter array
+     * @param string   $key       optional key for callback
+     * @param bool     $replace   if true replace existing keyed callback
+     */
+    public function registerPostCompileCallback($callback, $parameter = array(), $key = null, $replace = false)
+    {
+        array_unshift($parameter, $callback);
+        if (isset($key)) {
+            if ($replace || !isset($this->postCompileCallbacks[$key])) {
+                $this->postCompileCallbacks[$key] = $parameter;
+            }
+        } else {
+            $this->postCompileCallbacks[] = $parameter;
+        }
+    }
+
+    /**
+     * Remove a post compile callback
+     *
+     * @param string $key callback key
+     */
+    public function unregisterPostCompileCallback($key)
+    {
+        unset($this->postCompileCallbacks[$key]);
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_print_expression.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_print_expression.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_print_expression.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $optional_attributes = array('assign');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -34,14 +35,14 @@
     /**
      * Compiles code for generating output from any expression
      *
-     * @param array  $args      array with attributes from parser
+     * @param array                                 $args      array with attributes from parser
-     * @param object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param array  $parameter array with compilation parameter
+     * @param array                                 $parameter array with compilation parameter
      *
-     * @throws SmartyException
-     * @return string compiled code
+     * @return string
+     * @throws \SmartyException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -57,7 +58,8 @@
             $output = $parameter['value'];
             // tag modifier
             if (!empty($parameter['modifierlist'])) {
-                $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifierlist'], 'value' => $output));
+                $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => $parameter['modifierlist'],
+                                                                                   'value'        => $output));
             }
             if (!$_attr['nofilter']) {
                 // default modifier
@@ -74,7 +76,8 @@
                         }
                         $compiler->default_modifier_list = $modifierlist;
                     }
-                    $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => $compiler->default_modifier_list, 'value' => $output));
+                    $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => $compiler->default_modifier_list,
+                                                                                       'value'        => $output));
                 }
                 // autoescape html
                 if ($compiler->template->smarty->escape_html) {
@@ -82,7 +85,8 @@
                 }
                 // loop over registered filters
                 if (!empty($compiler->template->smarty->registered_filters[Smarty::FILTER_VARIABLE])) {
-                    foreach ($compiler->template->smarty->registered_filters[Smarty::FILTER_VARIABLE] as $key => $function) {
+                    foreach ($compiler->template->smarty->registered_filters[Smarty::FILTER_VARIABLE] as $key =>
+                             $function) {
                         if (!is_array($function)) {
                             $output = "{$function}({$output},\$_smarty_tpl)";
                         } elseif (is_object($function[0])) {
@@ -104,16 +108,17 @@
                         }
                     }
                 }
-                if (isset($compiler->template->variable_filters)) {
-                    foreach ($compiler->template->variable_filters as $filter) {
-                        if (count($filter) == 1 && ($result = $this->compile_output_filter($compiler, $filter[0], $output)) !== false) {
+                foreach ($compiler->variable_filters as $filter) {
+                    if (count($filter) == 1 &&
+                        ($result = $this->compile_output_filter($compiler, $filter[0], $output)) !== false
+                    ) {
-                            $output = $result;
-                        } else {
+                        $output = $result;
+                    } else {
-                            $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => array($filter), 'value' => $output));
+                        $output = $compiler->compileTag('private_modifier', array(), array('modifierlist' => array($filter),
+                                                                                           'value'        => $output));
-                        }
-                    }
-                }
+                    }
+                }
+            }
-            }
 
             $compiler->has_output = true;
             $output = "<?php echo {$output};?>";
@@ -123,23 +128,23 @@
     }
 
     /**
-     * @param object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
-     * @param string $name     name of variable filter
+     * @param string                                $name     name of variable filter
-     * @param string   $output   embedded output
+     * @param string                                $output   embedded output
      *
      * @return string
      */
-    private function compile_output_filter($compiler, $name, $output)
+    private function compile_output_filter(Smarty_Internal_TemplateCompilerBase $compiler, $name, $output)
     {
         $plugin_name = "smarty_variablefilter_{$name}";
         $path = $compiler->smarty->loadPlugin($plugin_name, false);
         if ($path) {
             if ($compiler->template->caching) {
-                $compiler->template->required_plugins['nocache'][$name][Smarty::FILTER_VARIABLE]['file'] = $path;
-                $compiler->template->required_plugins['nocache'][$name][Smarty::FILTER_VARIABLE]['function'] = $plugin_name;
+                $compiler->parent_compiler->template->compiled->required_plugins['nocache'][$name][Smarty::FILTER_VARIABLE]['file'] = $path;
+                $compiler->parent_compiler->template->compiled->required_plugins['nocache'][$name][Smarty::FILTER_VARIABLE]['function'] = $plugin_name;
             } else {
-                $compiler->template->required_plugins['compiled'][$name][Smarty::FILTER_VARIABLE]['file'] = $path;
-                $compiler->template->required_plugins['compiled'][$name][Smarty::FILTER_VARIABLE]['function'] = $plugin_name;
+                $compiler->parent_compiler->template->compiled->required_plugins['compiled'][$name][Smarty::FILTER_VARIABLE]['file'] = $path;
+                $compiler->parent_compiler->template->compiled->required_plugins['compiled'][$name][Smarty::FILTER_VARIABLE]['function'] = $plugin_name;
             }
         } else {
             // not found
